diff -Nur linux-2.4.30/include/linux/rbtree-24.h linux-2.4.30-linux-mips.org/include/linux/rbtree-24.h
--- linux-2.4.30/include/linux/rbtree-24.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.4.30-linux-mips.org/include/linux/rbtree-24.h	2005-05-12 18:01:30.000000000 +0200
@@ -0,0 +1,133 @@
+/*
+  Red Black Trees
+  (C) 1999  Andrea Arcangeli <andrea@suse.de>
+  
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License
+  along with this program; if not, write to the Free Software
+  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+  linux/include/linux/rbtree.h
+
+  To use rbtrees you'll have to implement your own insert and search cores.
+  This will avoid us to use callbacks and to drop drammatically performances.
+  I know it's not the cleaner way,  but in C (not in C++) to get
+  performances and genericity...
+
+  Some example of insert and search follows here. The search is a plain
+  normal search over an ordered tree. The insert instead must be implemented
+  int two steps: as first thing the code must insert the element in
+  order as a red leaf in the tree, then the support library function
+  rb_insert_color() must be called. Such function will do the
+  not trivial work to rebalance the rbtree if necessary.
+
+-----------------------------------------------------------------------
+static inline struct page * rb_search_page_cache(struct inode * inode,
+						 unsigned long offset)
+{
+	rb_node_t * n = inode->i_rb_page_cache.rb_node;
+	struct page * page;
+
+	while (n)
+	{
+		page = rb_entry(n, struct page, rb_page_cache);
+
+		if (offset < page->offset)
+			n = n->rb_left;
+		else if (offset > page->offset)
+			n = n->rb_right;
+		else
+			return page;
+	}
+	return NULL;
+}
+
+static inline struct page * __rb_insert_page_cache(struct inode * inode,
+						   unsigned long offset,
+						   rb_node_t * node)
+{
+	rb_node_t ** p = &inode->i_rb_page_cache.rb_node;
+	rb_node_t * parent = NULL;
+	struct page * page;
+
+	while (*p)
+	{
+		parent = *p;
+		page = rb_entry(parent, struct page, rb_page_cache);
+
+		if (offset < page->offset)
+			p = &(*p)->rb_left;
+		else if (offset > page->offset)
+			p = &(*p)->rb_right;
+		else
+			return page;
+	}
+
+	rb_link_node(node, parent, p);
+
+	return NULL;
+}
+
+static inline struct page * rb_insert_page_cache(struct inode * inode,
+						 unsigned long offset,
+						 rb_node_t * node)
+{
+	struct page * ret;
+	if ((ret = __rb_insert_page_cache(inode, offset, node)))
+		goto out;
+	rb_insert_color(node, &inode->i_rb_page_cache);
+ out:
+	return ret;
+}
+-----------------------------------------------------------------------
+*/
+
+#ifndef	_LINUX_RBTREE_H
+#define	_LINUX_RBTREE_H
+
+#include <linux/kernel.h>
+#include <linux/stddef.h>
+
+typedef struct rb_node_s
+{
+	struct rb_node_s * rb_parent;
+	int rb_color;
+#define	RB_RED		0
+#define	RB_BLACK	1
+	struct rb_node_s * rb_right;
+	struct rb_node_s * rb_left;
+}
+rb_node_t;
+
+typedef struct rb_root_s
+{
+	struct rb_node_s * rb_node;
+}
+rb_root_t;
+
+#define RB_ROOT	(rb_root_t) { NULL, }
+#define	rb_entry(ptr, type, member)					\
+	((type *)((char *)(ptr)-(unsigned long)(&((type *)0)->member)))
+
+extern void rb_insert_color(rb_node_t *, rb_root_t *);
+extern void rb_erase(rb_node_t *, rb_root_t *);
+
+static inline void rb_link_node(rb_node_t * node, rb_node_t * parent, rb_node_t ** rb_link)
+{
+	node->rb_parent = parent;
+	node->rb_color = RB_RED;
+	node->rb_left = node->rb_right = NULL;
+
+	*rb_link = node;
+}
+
+#endif	/* _LINUX_RBTREE_H */
diff -Nur linux-2.4.30/include/linux/rbtree.h linux-2.4.30-linux-mips.org/include/linux/rbtree.h
--- linux-2.4.30/include/linux/rbtree.h	2004-11-17 12:54:22.000000000 +0100
+++ linux-2.4.30-linux-mips.org/include/linux/rbtree.h	2005-05-12 18:01:30.000000000 +0200
@@ -1,139 +1,25 @@
 /*
-  Red Black Trees
-  (C) 1999  Andrea Arcangeli <andrea@suse.de>
-  
-  This program is free software; you can redistribute it and/or modify
-  it under the terms of the GNU General Public License as published by
-  the Free Software Foundation; either version 2 of the License, or
-  (at your option) any later version.
-
-  This program is distributed in the hope that it will be useful,
-  but WITHOUT ANY WARRANTY; without even the implied warranty of
-  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-  GNU General Public License for more details.
-
-  You should have received a copy of the GNU General Public License
-  along with this program; if not, write to the Free Software
-  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-  linux/include/linux/rbtree.h
-
-  To use rbtrees you'll have to implement your own insert and search cores.
-  This will avoid us to use callbacks and to drop drammatically performances.
-  I know it's not the cleaner way,  but in C (not in C++) to get
-  performances and genericity...
-
-  Some example of insert and search follows here. The search is a plain
-  normal search over an ordered tree. The insert instead must be implemented
-  int two steps: as first thing the code must insert the element in
-  order as a red leaf in the tree, then the support library function
-  rb_insert_color() must be called. Such function will do the
-  not trivial work to rebalance the rbtree if necessary.
-
------------------------------------------------------------------------
-static inline struct page * rb_search_page_cache(struct inode * inode,
-						 unsigned long offset)
-{
-	rb_node_t * n = inode->i_rb_page_cache.rb_node;
-	struct page * page;
-
-	while (n)
-	{
-		page = rb_entry(n, struct page, rb_page_cache);
-
-		if (offset < page->offset)
-			n = n->rb_left;
-		else if (offset > page->offset)
-			n = n->rb_right;
-		else
-			return page;
-	}
-	return NULL;
-}
-
-static inline struct page * __rb_insert_page_cache(struct inode * inode,
-						   unsigned long offset,
-						   rb_node_t * node)
-{
-	rb_node_t ** p = &inode->i_rb_page_cache.rb_node;
-	rb_node_t * parent = NULL;
-	struct page * page;
-
-	while (*p)
-	{
-		parent = *p;
-		page = rb_entry(parent, struct page, rb_page_cache);
-
-		if (offset < page->offset)
-			p = &(*p)->rb_left;
-		else if (offset > page->offset)
-			p = &(*p)->rb_right;
-		else
-			return page;
-	}
-
-	rb_link_node(node, parent, p);
-
-	return NULL;
-}
-
-static inline struct page * rb_insert_page_cache(struct inode * inode,
-						 unsigned long offset,
-						 rb_node_t * node)
-{
-	struct page * ret;
-	if ((ret = __rb_insert_page_cache(inode, offset, node)))
-		goto out;
-	rb_insert_color(node, &inode->i_rb_page_cache);
- out:
-	return ret;
-}
------------------------------------------------------------------------
-*/
-
-#ifndef	_LINUX_RBTREE_H
-#define	_LINUX_RBTREE_H
-
-#include <linux/kernel.h>
-#include <linux/stddef.h>
-
-typedef struct rb_node_s
-{
-	struct rb_node_s * rb_parent;
-	int rb_color;
-#define	RB_RED		0
-#define	RB_BLACK	1
-	struct rb_node_s * rb_right;
-	struct rb_node_s * rb_left;
-}
-rb_node_t;
-
-typedef struct rb_root_s
-{
-	struct rb_node_s * rb_node;
-}
-rb_root_t;
-
-#define RB_ROOT	(rb_root_t) { NULL, }
-#define	rb_entry(ptr, type, member)					\
-	((type *)((char *)(ptr)-(unsigned long)(&((type *)0)->member)))
+ * 2.5 compatibility
+ * $Id: rbtree.h,v 1.3 2003/01/14 13:56:05 dwmw2 Exp $
+ */
+
+#ifndef __MTD_COMPAT_RBTREE_H__
+#define __MTD_COMPAT_RBTREE_H__
+
+#include <linux/version.h>
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,5,40)
+#include_next <linux/rbtree.h>
+#else
+#define rb_node_s rb_node
+#define rb_root_s rb_root
 
-extern void rb_insert_color(rb_node_t *, rb_root_t *);
-extern void rb_erase(rb_node_t *, rb_root_t *);
+#include <linux/rbtree-24.h>
 
 /* Find logical next and previous nodes in a tree */
-extern rb_node_t *rb_next(rb_node_t *);
-extern rb_node_t *rb_prev(rb_node_t *);
-extern rb_node_t *rb_first(rb_root_t *);
-extern rb_node_t *rb_last(rb_root_t *);
-
-static inline void rb_link_node(rb_node_t * node, rb_node_t * parent, rb_node_t ** rb_link)
-{
-	node->rb_parent = parent;
-	node->rb_color = RB_RED;
-	node->rb_left = node->rb_right = NULL;
+extern struct rb_node *rb_next(struct rb_node *);
+extern struct rb_node *rb_prev(struct rb_node *);
+extern struct rb_node *rb_first(struct rb_root *);
+#endif
 
-	*rb_link = node;
-}
-
-#endif	/* _LINUX_RBTREE_H */
+#endif /*  __MTD_COMPAT_RBTREE_H__ */
diff -Nur linux-2.4.30/include/linux/sched.h linux-2.4.30-linux-mips.org/include/linux/sched.h
--- linux-2.4.30/include/linux/sched.h	2005-01-19 15:10:12.000000000 +0100
+++ linux-2.4.30-linux-mips.org/include/linux/sched.h	2005-05-12 17:57:55.000000000 +0200
@@ -617,6 +617,10 @@
 extern int in_group_p(gid_t);
 extern int in_egroup_p(gid_t);
 
+extern ATTRIB_NORET void cpu_idle(void);
+
+extern void release_task(struct task_struct * p);
+
 extern void proc_caches_init(void);
 extern void flush_signals(struct task_struct *);
 extern void flush_signal_handlers(struct task_struct *);
diff -Nur linux-2.4.30/include/linux/serial.h linux-2.4.30-linux-mips.org/include/linux/serial.h
--- linux-2.4.30/include/linux/serial.h	2002-08-03 02:39:45.000000000 +0200
+++ linux-2.4.30-linux-mips.org/include/linux/serial.h	2005-05-12 17:57:55.000000000 +0200
@@ -75,7 +75,8 @@
 #define PORT_16654	11
 #define PORT_16850	12
 #define PORT_RSA	13	/* RSA-DV II/S card */
-#define PORT_MAX	13
+#define PORT_SB1250	14
+#define PORT_MAX	14
 
 #define SERIAL_IO_PORT	0
 #define SERIAL_IO_HUB6	1
diff -Nur linux-2.4.30/include/linux/suspend.h linux-2.4.30-linux-mips.org/include/linux/suspend.h
--- linux-2.4.30/include/linux/suspend.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.4.30-linux-mips.org/include/linux/suspend.h	2005-05-12 18:01:30.000000000 +0200
@@ -0,0 +1,10 @@
+/* $Id: suspend.h,v 1.1 2003/10/13 20:56:47 dwmw2 Exp $ */
+
+#ifndef __MTD_COMPAT_VERSION_H__
+#include <linux/version.h>
+
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,0)
+#include_next <linux/suspend.h>
+#endif
+
+#endif /* __MTD_COMPAT_VERSION_H__ */
diff -Nur linux-2.4.30/include/linux/swap.h linux-2.4.30-linux-mips.org/include/linux/swap.h
--- linux-2.4.30/include/linux/swap.h	2005-01-19 15:10:12.000000000 +0100
+++ linux-2.4.30-linux-mips.org/include/linux/swap.h	2005-05-12 17:57:55.000000000 +0200
@@ -1,6 +1,12 @@
 #ifndef _LINUX_SWAP_H
 #define _LINUX_SWAP_H
 
+#include <linux/config.h>
+
+#define MAX_SWAPFILES 32
+
+#ifdef __KERNEL__
+
 #include <linux/spinlock.h>
 #include <asm/page.h>
 
@@ -8,8 +14,6 @@
 #define SWAP_FLAG_PRIO_MASK	0x7fff
 #define SWAP_FLAG_PRIO_SHIFT	0
 
-#define MAX_SWAPFILES 32
-
 /*
  * Magic header for a swap area. The first part of the union is
  * what the swap magic looks like for the old (limited to 128MB)
@@ -39,8 +43,6 @@
 	} info;
 };
 
-#ifdef __KERNEL__
-
 /*
  * Max bad pages in the new format..
  */
diff -Nur linux-2.4.30/include/linux/sysctl.h linux-2.4.30-linux-mips.org/include/linux/sysctl.h
--- linux-2.4.30/include/linux/sysctl.h	2005-04-04 03:42:20.000000000 +0200
+++ linux-2.4.30-linux-mips.org/include/linux/sysctl.h	2005-05-12 18:01:29.000000000 +0200
@@ -69,7 +69,8 @@
 /* CTL_BUS names: */
 enum
 {
-	CTL_BUS_ISA=1		/* ISA */
+	CTL_BUS_ISA=1,		/* ISA */
+ 	CTL_BUS_MMC=2		/* MultiMedia Card */
 };
 
 /* CTL_KERN names: */
diff -Nur linux-2.4.30/include/linux/usb_otg.h linux-2.4.30-linux-mips.org/include/linux/usb_otg.h
--- linux-2.4.30/include/linux/usb_otg.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.4.30-linux-mips.org/include/linux/usb_otg.h	2005-05-12 18:01:29.000000000 +0200
@@ -0,0 +1,217 @@
+/**
+ * <linux/usb_otg.h>
+ *
+ * Copyright 2004 ADVANCED MICRO DEVICES, INC.
+ *
+ * karsten.boge@amd.com
+ */
+#ifndef __LINUX_USB_OTG_H
+#define __LINUX_USB_OTG_H
+
+
+/*
+ * OTG device flags
+ */
+#define USB_OTG_CONNECT_VALID		0x01	/* connected to OTG port     */
+#define USB_OTG_HNP_ENABLED		0x02	/* device is ready for HNP   */
+
+/*
+ * SET_FEATURE data
+ */
+#define USB_OTG_B_HNP_ENABLE		0x03	/* enables HNP in B-device   */
+#define USB_OTG_A_HNP_SUPPORT		0x04	/* signals HNP capability    */
+#define USB_OTG_A_ALT_HNP_SUPPORT	0x05	/* HNP, but no OTG connect   */
+
+/*
+ * OTG state definitions
+ */
+#define OTG_STATE_MASK                  0xF0
+
+#define OTG_NOT_ASSIGNED                0
+#define OTG_NO_B_DEVICE_A               (0x6 | OTG_NOT_ASSIGNED)
+#define OTG_NO_B_DEVICE_B               (0x4 | OTG_NOT_ASSIGNED)
+
+#define OTG_A_IDLE                      0x10
+#define OTG_A_IDLE_WAIT_DP              (1 | OTG_A_IDLE)
+#define OTG_A_IDLE_WAIT_VP              (2 | OTG_A_IDLE)
+#define OTG_A_IDLE_WAIT_MP              (3 | OTG_A_IDLE)
+#define OTG_A_IDLE_WAIT_DV              (4 | OTG_A_IDLE)
+#define OTG_A_WAIT_VRISE                0xB0
+#define OTG_A_WAIT_BCON                 0x30
+#define OTG_A_WAIT_BCON_VB              (1 | OTG_A_WAIT_BCON)
+#define OTG_A_HOST                      0x50
+#define OTG_A_SUSPEND                   0x70
+#define OTG_A_PERIPHERAL                0x90
+#define OTG_A_VBUS_ERROR                0xF0
+#define OTG_A_WAIT_VFALL                0xD0
+#define OTG_A_WAIT_VFALL_DN             (1 | OTG_A_WAIT_VFALL)
+#ifdef CONFIG_USB_OTG_FORCE_SUSPEND
+#define OTG_A_WAIT_BDISCON              0x40
+#define OTG_A_WAIT_BSUSPEND             (1 | OTG_A_WAIT_BDISCON)
+#endif
+
+#define OTG_B_IDLE                      0x20
+#define OTG_B_PERIPHERAL                0x80
+#define OTG_B_PERIPHERAL_WT             (1 | OTG_B_PERIPHERAL)
+#define OTG_B_PERIPHERAL_DC             (2 | OTG_B_PERIPHERAL)
+#define OTG_B_WAIT_ACON                 0xA0
+#define OTG_B_HOST                      0xE0
+#define OTG_B_SRP_INIT                  0xC0
+#define OTG_B_SRP_INIT_WAIT_SE0         (1 | OTG_B_SRP_INIT)
+#define OTG_B_SRP_INIT_D_PULSE          (2 | OTG_B_SRP_INIT)
+#define OTG_B_SRP_INIT_V_PULSE          (3 | OTG_B_SRP_INIT)
+#define OTG_B_SRP_INIT_V_DCHRG          (4 | OTG_B_SRP_INIT)
+#define OTG_B_SRP_INIT_WAIT_VBUS        (5 | OTG_B_SRP_INIT)
+#ifdef CONFIG_USB_OTG_FORCE_SUSPEND
+#define OTG_B_WAIT_ADISCON              0x60
+#define OTG_B_WAIT_ASUSPEND             (1 | OTG_B_WAIT_ADISCON)
+#endif
+
+/*
+ * typical timer values (ms)
+ */
+/* !!! make sure none of the values below is less then the SYSTEM LATENCY !!!*/
+
+#define OTG_TMR_WAIT_VFALL     10        /* A waits for VBus                 */
+#define OTG_TMR_A_WAIT_VRISE   100       /* A waits for VBus                 */
+#define OTG_TMR_A_WAIT_BCON    200       /* A waits for B-connect (1.. s)    */
+#define OTG_TMR_A_IDLE_BDIS    250       /* A waits for B-disc (200.. ms)    */
+#define OTG_TMR_B_ASE0_BRST    5         /* B waits for A-conn (3.125.. ms)  */
+#define OTG_TMR_B_AIDL_BDIS    50        /* B waits before dc (5..150ms)     */
+#define OTG_TMR_SRP_WAIT_SE0   2         /* B SRP idle wait                  */
+#define OTG_TMR_SRP_WAIT_DP    8         /* B SRP D_PULSE (5..10ms)          */
+#define OTG_TMR_SRP_WAIT_VP    80        /* B SRP V_PULSE (5..100ms)         */
+#define OTG_TMR_SRP_DCHRG_V    30        /* B SRP VBus discharge             */
+#define OTG_TMR_SRP_WAIT_VRS   5800      /* B SRP waits for VBus (5..6s)     */
+#define OTG_TMR_ASRP_WAIT_MP   4         /* A SRP min. pulse                 */
+#define OTG_TMR_ASRP_WAIT_DP   10        /* A SRP D_PULSE TO                 */
+#define OTG_TMR_ASRP_WAIT_VP   200       /* A SRP V_PULSE TO                 */
+#define OTG_TMR_ASRP_WAIT_DV   200       /* A SRP waits for V_PULSE          */
+#define OTG_TMR_A_BCON_VB      50        /* A waits for VBus after connect   */
+#ifdef CONFIG_USB_OTG_FORCE_SUSPEND
+#define OTG_TMR_HOST_WAIT_SUSP 5         /* USB 2.0 ( ..3ms)                 */
+#define OTG_TMR_A_FS_BDIS      (OTG_TMR_HOST_WAIT_SUSP + OTG_TMR_A_IDLE_BDIS)
+#define OTG_TMR_B_WAIT_ADIS    OTG_TMR_A_IDLE_BDIS
+#define OTG_TMR_B_FS_ADIS      (OTG_TMR_HOST_WAIT_SUSP + OTG_TMR_B_WAIT_ADIS)
+#endif
+
+/*
+ * OTG state parameters
+ */
+#define OTG_HOST_READY         (1<<20)   /* indicates a USB host driver is   */
+                                         /* running                          */
+#define OTG_GADGET_READY       (1<<21)   /* indicates a USB gadget driver is */
+                                         /* running                          */
+#define OTG_A_BUS_REQ          (1<<22)   /* used by appl-SW to request a     */
+                                         /* VBus rise, auto-reset by driver  */
+#define OTG_A_BUS_DROP         (1<<23)   /* used by appl-SW to request a     */
+                                         /* VBus drop, auto-reset by driver  */
+#define OTG_A_bHNP_EN          (1<<24)   /* aapl-SW can use this to enable   */
+                                         /* HNP / indicates HNP is enabled   */
+                                         /* reset on USB port reset or SEnd  */
+#define OTG_A_CLR_ERR          (1<<25)   /* used by appl-SW to request VBerr */
+                                         /* clean-up, auto-reset by driver   */
+#define OTG_AB_HNP_REQ         (1<<26)   /* used by appl-SW to initiate      */
+                                         /* HNP, auto-reset by driver        */
+#define OTG_B_BUS_REQ          (1<<27)   /* used by appl-SW to request       */
+                                         /* B-device functionality, ...      */
+#define OTG_B_BUS_DIS          (1<<28)   /* used by appl-SW to request       */
+                                         /* disable B-device functionality   */
+#define OTG_B_aSSN_REQ         (1<<29)   /* used by appl-SW to initiate SRP, */
+                                         /* auto-reset by the driver         */
+#define OTG_B_SRP_ERROR        (1<<30)   /* indicates invalid HW conditions  */
+                                         /* during SRP, reset by writing "1" */
+#define OTG_A_VBUS_FAILED      (1<<31)   /* indicates a VBus error, reset by */
+                                         /* writing "1", when setting        */
+                                         /* CLR_ERR or when leaving A-states */
+
+#ifdef CONFIG_USB_OTG_FORCE_SUSPEND
+#define SW_REQUEST_MASK        (OTG_A_BUS_REQ | OTG_A_BUS_DROP | \
+                                OTG_A_bHNP_EN | OTG_A_CLR_ERR | \
+                                OTG_B_BUS_REQ | OTG_B_BUS_DIS | \
+                                OTG_B_aSSN_REQ | OTG_AB_HNP_REQ)
+#else
+#define SW_REQUEST_MASK        (OTG_A_BUS_REQ | OTG_A_BUS_DROP | \
+                                OTG_A_bHNP_EN | OTG_A_CLR_ERR | \
+                                OTG_B_BUS_REQ | OTG_B_BUS_DIS | \
+                                OTG_B_aSSN_REQ)
+#endif
+
+/*********************************************************************/
+
+/*
+ * gadget events for notify function
+ */
+#define OTG_GADGET_EVT_SVDROP  1         /* Session valid drop       */
+#define OTG_GADGET_EVT_SVALID  2         /* Session valid            */
+
+/*** HS-A0 WA: gadget phy suspend issue                            ***/
+#define OTG_FLAGS_UDC_SUSP     (1<<17)   /* gadget phy suspended     */
+
+/*********************************************************************/
+
+#ifdef __KERNEL__
+/*
+ * fsm variables
+ */
+struct otg_ctl {
+	int  act_state;		/* OTG actual state */
+	int  prv_state;		/* OTG previous state */
+	int  params;		/* OTG state parameters */
+};
+
+struct otg {
+	spinlock_t        lock;
+	int               hostcount;
+	int               gadgetflag;
+	struct usb_device *device;
+	unsigned          enabled : 1,
+	                  got_irq : 1,
+	                  region : 1,
+	                  selfpowered : 1;
+	u16               chiprev;
+	/* pci state used to access those endpoints */
+	struct pci_dev   *pdev;
+	struct otg_regs  *regs;
+	struct otg_ctl   *otg_ctl;
+};
+
+/*
+ * To be allocated once for one OTG controller
+ */
+struct usbcore_otg_extension {
+	int  (*bind) (struct usb_bus *);
+	int  (*unbind) (struct usb_bus *);
+	int  (*request) (u32);	/* function call for state change requests */
+	u32  (*query) (int);	/* function call to query state */
+};
+
+struct usb_gadget_otg_extension {
+	int  (*bind) (void);
+	int  (*unbind) (void);
+	int  (*request) (u32);	/* function call for state change requests */
+	u32  (*query) (int);	/* function call to query state */
+	int  (*notify) (int);   /* report events to the gadget driver */
+};
+
+/*
+ * To be allocated for each OTG capabel host (assuming 1 OTG port)
+ */
+struct usb_otg_host {
+	int   otgport;		/* port supporting OTG (-1 for none) */
+	void *otgpriv;		/* OTG controller private data */
+};
+
+
+int usb_bus_register_otg (struct usbcore_otg_extension *);
+int usb_bus_deregister_otg (struct usbcore_otg_extension *);
+int usb_gadget_register_otg (struct usb_gadget_otg_extension *);
+int usb_gadget_unregister_otg (struct usb_gadget_otg_extension *);
+int usb_otg_enable_b_hnp (struct usb_device *);
+
+int usb_check_otg_support (struct pci_dev *, struct usb_bus *);
+void usb_release_otg_host (struct usb_bus *);
+
+#endif
+
+#endif /* __LINUX_USB_OTG_H */
diff -Nur linux-2.4.30/include/linux/workqueue.h linux-2.4.30-linux-mips.org/include/linux/workqueue.h
--- linux-2.4.30/include/linux/workqueue.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.4.30-linux-mips.org/include/linux/workqueue.h	2005-05-12 18:01:30.000000000 +0200
@@ -0,0 +1,21 @@
+/*
+ * 2.5 compatibility 
+ * $Id: workqueue.h,v 1.1 2002/11/11 16:39:10 dwmw2 Exp $
+ */
+
+#ifndef __MTD_COMPAT_WORKQUEUE_H__
+#define __MTD_COMPAT_WORKQUEUE_H__
+
+#include <linux/version.h>
+
+#if LINUX_VERSION_CODE > KERNEL_VERSION(2,5,40)
+#include_next <linux/workqueue.h>
+#else
+#include <linux/tqueue.h>
+#define work_struct tq_struct
+#define schedule_work(x) schedule_task(x)
+#define flush_scheduled_work flush_scheduled_tasks
+#define INIT_WORK(x,y,z) INIT_TQUEUE(x,y,z)
+#endif
+
+#endif /* __MTD_COMPAT_WORKQUEUE_H__ */
diff -Nur linux-2.4.30/include/mtd/inftl-user.h linux-2.4.30-linux-mips.org/include/mtd/inftl-user.h
--- linux-2.4.30/include/mtd/inftl-user.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.4.30-linux-mips.org/include/mtd/inftl-user.h	2005-05-12 18:01:29.000000000 +0200
@@ -0,0 +1,91 @@
+/*
+ * $Id: inftl-user.h,v 1.1 2004/05/05 15:17:00 dwmw2 Exp $
+ *
+ * Parts of INFTL headers shared with userspace 
+ *
+ */
+
+#ifndef __MTD_INFTL_USER_H__
+#define __MTD_INFTL_USER_H__
+
+#define	OSAK_VERSION	0x5120
+#define	PERCENTUSED	98
+
+#define	SECTORSIZE	512
+
+/* Block Control Information */
+
+struct inftl_bci {
+	uint8_t ECCsig[6];
+	uint8_t Status;
+	uint8_t Status1;
+} __attribute__((packed));
+
+struct inftl_unithead1 {
+	uint16_t virtualUnitNo;
+	uint16_t prevUnitNo;
+	uint8_t ANAC;
+	uint8_t NACs;
+	uint8_t parityPerField;
+	uint8_t discarded;
+} __attribute__((packed));
+
+struct inftl_unithead2 {
+	uint8_t parityPerField;
+	uint8_t ANAC;
+	uint16_t prevUnitNo;
+	uint16_t virtualUnitNo;
+	uint8_t NACs;
+	uint8_t discarded;
+} __attribute__((packed));
+
+struct inftl_unittail {
+	uint8_t Reserved[4];
+	uint16_t EraseMark;
+	uint16_t EraseMark1;
+} __attribute__((packed));
+
+union inftl_uci {
+	struct inftl_unithead1 a;
+	struct inftl_unithead2 b;
+	struct inftl_unittail c;
+};
+
+struct inftl_oob {
+	struct inftl_bci b;
+	union inftl_uci u;
+};
+
+
+/* INFTL Media Header */
+
+struct INFTLPartition {
+	__u32 virtualUnits;
+	__u32 firstUnit;
+	__u32 lastUnit;
+	__u32 flags;
+	__u32 spareUnits;
+	__u32 Reserved0;
+	__u32 Reserved1;
+} __attribute__((packed));
+
+struct INFTLMediaHeader {
+	char bootRecordID[8];
+	__u32 NoOfBootImageBlocks;
+	__u32 NoOfBinaryPartitions;
+	__u32 NoOfBDTLPartitions;
+	__u32 BlockMultiplierBits;
+	__u32 FormatFlags;
+	__u32 OsakVersion;
+	__u32 PercentUsed;
+	struct INFTLPartition Partitions[4];
+} __attribute__((packed));
+
+/* Partition flag types */
+#define	INFTL_BINARY	0x20000000
+#define	INFTL_BDTL	0x40000000
+#define	INFTL_LAST	0x80000000
+
+#endif /* __MTD_INFTL_USER_H__ */
+
+
diff -Nur linux-2.4.30/include/mtd/jffs2-user.h linux-2.4.30-linux-mips.org/include/mtd/jffs2-user.h
--- linux-2.4.30/include/mtd/jffs2-user.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.4.30-linux-mips.org/include/mtd/jffs2-user.h	2005-05-12 18:01:29.000000000 +0200
@@ -0,0 +1,35 @@
+/*
+ * $Id: jffs2-user.h,v 1.1 2004/05/05 11:57:54 dwmw2 Exp $
+ *
+ * JFFS2 definitions for use in user space only
+ */
+
+#ifndef __JFFS2_USER_H__
+#define __JFFS2_USER_H__
+
+/* This file is blessed for inclusion by userspace */
+#include <linux/jffs2.h>
+#include <endian.h>
+#include <byteswap.h>
+
+#undef cpu_to_je16
+#undef cpu_to_je32
+#undef cpu_to_jemode
+#undef je16_to_cpu
+#undef je32_to_cpu
+#undef jemode_to_cpu
+
+extern int target_endian;
+
+#define t16(x) ({ uint16_t __b = (x); (target_endian==__BYTE_ORDER)?__b:bswap_16(__b); })
+#define t32(x) ({ uint32_t __b = (x); (target_endian==__BYTE_ORDER)?__b:bswap_32(__b); })
+
+#define cpu_to_je16(x) ((jint16_t){t16(x)})
+#define cpu_to_je32(x) ((jint32_t){t32(x)})
+#define cpu_to_jemode(x) ((jmode_t){t32(x)})
+
+#define je16_to_cpu(x) (t16((x).v16))
+#define je32_to_cpu(x) (t32((x).v32))
+#define jemode_to_cpu(x) (t32((x).m))
+
+#endif /* __JFFS2_USER_H__ */
diff -Nur linux-2.4.30/include/mtd/mtd-abi.h linux-2.4.30-linux-mips.org/include/mtd/mtd-abi.h
--- linux-2.4.30/include/mtd/mtd-abi.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.4.30-linux-mips.org/include/mtd/mtd-abi.h	2005-05-12 18:01:29.000000000 +0200
@@ -0,0 +1,93 @@
+/*
+ * $Id: mtd-abi.h,v 1.1 2004/05/05 14:44:57 dwmw2 Exp $
+ *
+ * Portions of MTD ABI definition which are shared by kernel and user space 
+ */
+
+#ifndef __MTD_ABI_H__
+#define __MTD_ABI_H__
+
+struct erase_info_user {
+	uint32_t start;
+	uint32_t length;
+};
+
+struct mtd_oob_buf {
+	uint32_t start;
+	uint32_t length;
+	unsigned char *ptr;
+};
+
+#define MTD_ABSENT		0
+#define MTD_RAM			1
+#define MTD_ROM			2
+#define MTD_NORFLASH		3
+#define MTD_NANDFLASH		4
+#define MTD_PEROM		5
+#define MTD_OTHER		14
+#define MTD_UNKNOWN		15
+
+#define MTD_CLEAR_BITS		1       // Bits can be cleared (flash)
+#define MTD_SET_BITS		2       // Bits can be set
+#define MTD_ERASEABLE		4       // Has an erase function
+#define MTD_WRITEB_WRITEABLE	8       // Direct IO is possible
+#define MTD_VOLATILE		16      // Set for RAMs
+#define MTD_XIP			32	// eXecute-In-Place possible
+#define MTD_OOB			64	// Out-of-band data (NAND flash)
+#define MTD_ECC			128	// Device capable of automatic ECC
+
+// Some common devices / combinations of capabilities
+#define MTD_CAP_ROM		0
+#define MTD_CAP_RAM		(MTD_CLEAR_BITS|MTD_SET_BITS|MTD_WRITEB_WRITEABLE)
+#define MTD_CAP_NORFLASH        (MTD_CLEAR_BITS|MTD_ERASEABLE)
+#define MTD_CAP_NANDFLASH       (MTD_CLEAR_BITS|MTD_ERASEABLE|MTD_OOB)
+#define MTD_WRITEABLE		(MTD_CLEAR_BITS|MTD_SET_BITS)
+
+
+// Types of automatic ECC/Checksum available
+#define MTD_ECC_NONE		0 	// No automatic ECC available
+#define MTD_ECC_RS_DiskOnChip	1	// Automatic ECC on DiskOnChip
+#define MTD_ECC_SW		2	// SW ECC for Toshiba & Samsung devices
+
+/* ECC byte placement */
+#define MTD_NANDECC_OFF		0	// Switch off ECC (Not recommended)
+#define MTD_NANDECC_PLACE	1	// Use the given placement in the structure
+#define MTD_NANDECC_AUTOPLACE	2	// Use the default placement scheme
+
+struct mtd_info_user {
+	uint8_t type;
+	uint32_t flags;
+	uint32_t size;	 // Total size of the MTD
+	uint32_t erasesize;
+	uint32_t oobblock;  // Size of OOB blocks (e.g. 512)
+	uint32_t oobsize;   // Amount of OOB data per block (e.g. 16)
+	uint32_t ecctype;
+	uint32_t eccsize;
+};
+
+struct region_info_user {
+	uint32_t offset;		/* At which this region starts, 
+					 * from the beginning of the MTD */
+	uint32_t erasesize;		/* For this region */
+	uint32_t numblocks;		/* Number of blocks in this region */
+	uint32_t regionindex;
+};
+
+#define MEMGETINFO              _IOR('M', 1, struct mtd_info_user)
+#define MEMERASE                _IOW('M', 2, struct erase_info_user)
+#define MEMWRITEOOB             _IOWR('M', 3, struct mtd_oob_buf)
+#define MEMREADOOB              _IOWR('M', 4, struct mtd_oob_buf)
+#define MEMLOCK                 _IOW('M', 5, struct erase_info_user)
+#define MEMUNLOCK               _IOW('M', 6, struct erase_info_user)
+#define MEMGETREGIONCOUNT	_IOR('M', 7, int)
+#define MEMGETREGIONINFO	_IOWR('M', 8, struct region_info_user)
+#define MEMSETOOBSEL		_IOW('M', 9, struct nand_oobinfo)
+
+struct nand_oobinfo {
+	int	useecc;
+	int	eccbytes;
+	int	eccpos[24];
+	int	oobfree[8][2];
+};
+
+#endif /* __MTD_ABI_H__ */
diff -Nur linux-2.4.30/include/mtd/mtd-user.h linux-2.4.30-linux-mips.org/include/mtd/mtd-user.h
--- linux-2.4.30/include/mtd/mtd-user.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.4.30-linux-mips.org/include/mtd/mtd-user.h	2005-05-12 18:01:29.000000000 +0200
@@ -0,0 +1,20 @@
+/*
+ * $Id: mtd-user.h,v 1.2 2004/05/05 14:44:57 dwmw2 Exp $
+ *
+ * MTD ABI header for use by user space only.
+ */
+
+#ifndef __MTD_USER_H__
+#define __MTD_USER_H__
+
+#include <stdint.h>
+
+/* This file is blessed for inclusion by userspace */
+#include <mtd/mtd-abi.h>
+
+typedef struct mtd_info_user mtd_info_t;
+typedef struct erase_info_user erase_info_t;
+typedef struct region_info_user region_info_t;
+typedef struct nand_oobinfo nand_oobinfo_t;
+
+#endif /* __MTD_USER_H__ */
diff -Nur linux-2.4.30/include/mtd/nftl-user.h linux-2.4.30-linux-mips.org/include/mtd/nftl-user.h
--- linux-2.4.30/include/mtd/nftl-user.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.4.30-linux-mips.org/include/mtd/nftl-user.h	2005-05-12 18:01:29.000000000 +0200
@@ -0,0 +1,76 @@
+/*
+ * $Id: nftl-user.h,v 1.1 2004/05/05 14:44:57 dwmw2 Exp $
+ *
+ * Parts of NFTL headers shared with userspace 
+ *
+ */
+
+#ifndef __MTD_NFTL_USER_H__
+#define __MTD_NFTL_USER_H__
+
+/* Block Control Information */
+
+struct nftl_bci {
+	unsigned char ECCSig[6];
+	uint8_t Status;
+	uint8_t Status1;
+}__attribute__((packed));
+
+/* Unit Control Information */
+
+struct nftl_uci0 {
+	uint16_t VirtUnitNum;
+	uint16_t ReplUnitNum;
+	uint16_t SpareVirtUnitNum;
+	uint16_t SpareReplUnitNum;
+} __attribute__((packed));
+
+struct nftl_uci1 {
+	uint32_t WearInfo;
+	uint16_t EraseMark;
+	uint16_t EraseMark1;
+} __attribute__((packed));
+
+struct nftl_uci2 {
+        uint16_t FoldMark;
+        uint16_t FoldMark1;
+	uint32_t unused;
+} __attribute__((packed));
+
+union nftl_uci {
+	struct nftl_uci0 a;
+	struct nftl_uci1 b;
+	struct nftl_uci2 c;
+};
+
+struct nftl_oob {
+	struct nftl_bci b;
+	union nftl_uci u;
+};
+
+/* NFTL Media Header */
+
+struct NFTLMediaHeader {
+	char DataOrgID[6];
+	uint16_t NumEraseUnits;
+	uint16_t FirstPhysicalEUN;
+	uint32_t FormattedSize;
+	unsigned char UnitSizeFactor;
+} __attribute__((packed));
+
+#define MAX_ERASE_ZONES (8192 - 512)
+
+#define ERASE_MARK 0x3c69
+#define SECTOR_FREE 0xff
+#define SECTOR_USED 0x55
+#define SECTOR_IGNORE 0x11
+#define SECTOR_DELETED 0x00
+
+#define FOLD_MARK_IN_PROGRESS 0x5555
+
+#define ZONE_GOOD 0xff
+#define ZONE_BAD_ORIGINAL 0
+#define ZONE_BAD_MARKED 7
+
+
+#endif /* __MTD_NFTL_USER_H__ */
diff -Nur linux-2.4.30/include/pcmcia/cs_types.h linux-2.4.30-linux-mips.org/include/pcmcia/cs_types.h
--- linux-2.4.30/include/pcmcia/cs_types.h	2004-02-18 14:36:32.000000000 +0100
+++ linux-2.4.30-linux-mips.org/include/pcmcia/cs_types.h	2005-05-12 18:01:29.000000000 +0200
@@ -36,8 +36,10 @@
 #include <sys/types.h>
 #endif
 
-#if defined(__arm__) || defined(__mips__)
+#if defined(__arm__)
 typedef u_int   ioaddr_t;
+#elif defined(__mips__)
+typedef unsigned long long ioaddr_t;
 #else
 typedef u_short	ioaddr_t;
 #endif
